unit UTurtle;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TTurtle = class(TObject)
  private
    h_xpos,h_ypos:Real;
    h_winkel:Real;
    h_gesenkt:Boolean;
    k_Leinwand:TCanvas;
  public
    constructor createturtle(x_p,y_p,winkel_p : Real;
                             gesenkt_p : Boolean;
                             Leinwand_p : TCanvas);
    procedure links (winkel : Real);
    procedure rechts(winkel : Real);
    procedure hoch;
    procedure runter;
    procedure vorwaerts (length:Real);

    { Public-Deklarationen }
  end;


implementation

constructor TTurtle.createturtle(x_p,y_p,winkel_p : Real;
                             gesenkt_p : Boolean;
                             Leinwand_p : TCanvas);
begin
   inherited create;
   h_xpos := x_p;
   h_ypos := y_p;
   h_winkel := winkel_p;
   h_gesenkt := gesenkt_p;
   k_Leinwand := Leinwand_p
end;

procedure TTurtle.links (winkel : Real);
begin
   h_winkel := h_winkel + winkel
end;

procedure TTurtle.rechts(winkel : Real);
begin
   h_winkel := h_winkel - winkel
end;

procedure TTurtle.hoch;
begin
   h_gesenkt  := false
end;

procedure TTurtle.runter;
begin
   h_gesenkt := true
end;

procedure TTurtle.vorwaerts (length:Real);
begin
   with k_Leinwand do
      begin
         moveto (round(h_xpos),round(h_ypos));
         h_xpos := h_xpos + length * cos (h_winkel * pi /180);
         h_ypos := h_ypos - length * sin (h_winkel * pi /180);
           // Dann zeigt ein Winkel von 90 Grad nach oben
         if h_gesenkt then
            lineto (round(h_xpos),round(h_ypos))
         else
            moveto (round(h_xpos),round(h_ypos))
      end
end;


end.
